Zen API

- Home
- Topics
- Types
- Files

All Classes Files Functions Variables Typedefs Friends Macros Modules Pages
Public Member Functions | Related
kArray1 Class Reference
kApi/Data

## Description

Represents a 1D array.

The kArray1 class represents a 1D array of objects or values. The kArray1 constructor accepts arguments that determine the array item type (kType) and array length.

For arrays that contain objects (e.g. kImage) as opposed to values (e.g. k32s), the objects are not automatically destroyed when the array is destroyed. To recursively destroy both the array and the array items, use kObject_Dispose.

kArray1 supports the kObject_Clone, kObject_Dispose, and kObject_Size methods.

kArray1 supports the kdat5 and kdat6 serialization protocols.

Inheritance diagram for kArray1:

## Public Member Functions
kStatus | kArray1_Allocate (kArray1 array, kType itemType, kSize length)
| Reallocates the internal array item buffer. More...
kStatus | kArray1_Assign (kArray1 array, kArray1 source)
| Performs a shallow copy of the source array. More...
void * | kArray1_At (kArray1 array, kSize index)
| Returns a pointer to the specified item in the array. More...
kStatus | kArray1_Attach (kArray1 array, void *items, kType itemType, kSize length)
| Attaches the array to an external item buffer. More...
kStatus | kArray1_Construct (kArray1 *array, kType itemType, kSize length, kAlloc allocator)
| Constructs a kArray1 object. More...
kStatus | kArray1_ConstructEx (kArray1 *array, kType itemType, kSize length, kAlloc allocator, kAlloc dataAllocator)
| Constructs a kArray1 object using a separate allocator for data array memory. More...
kSize | kArray1_Count (kArray1 array)
| Returns the array item count, in elements. More...
void * | kArray1_Data (kArray1 array)
| Returns a pointer to the array item buffer. More...
kAlloc | kArray1_DataAlloc (kArray1 array)
| Reports the data allocator that was optionally provided at construction time. More...
void * | kArray1_DataAt (kArray1 array, kSSize index)
| Calculates an address relative to the start of the buffer. More...
kSize | kArray1_DataSize (kArray1 array)
| Reports the size, in bytes, of the array item buffer. More...
kStatus | kArray1_Item (kArray1 array, kSize index, void *item)
| Gets the value of an item. More...
kSize | kArray1_ItemSize (kArray1 array)
| Returns the array item size. More...
kType | kArray1_ItemType (kArray1 array)
| Returns the array item type. More...
kSize | kArray1_Length (kArray1 array)
| Returns the array length, in elements. More...
kStatus | kArray1_Resize (kArray1 array, kSize length)
| Resizes the internal array item buffer. More...
kStatus | kArray1_SetItem (kArray1 array, kSize index, const void *item)
| Sets the value of an item. More...
kStatus | kArray1_Zero (kArray1 array)
| Sets all array element bits to zero. More...
Public Member Functions inherited from kObject
kAlloc | kObject_Alloc (kObject object)
| Gets the memory allocator associated with this object. More...
kStatus | kObject_Clone (kObject *object, kObject source, kAlloc allocator)
| Constructs a new object by copying an existing object, including any aggregated child elements. More...
kStatus | kObject_Destroy (kObject object)
| Destroys the object. More...
kStatus | kObject_Dispose (kObject object)
| Destroys the object and any aggregated child elements. More...
kBool | kObject_Equals (kObject object, kObject other)
| Determines whether the object is equal to another object. More...
kBool | kObject_HasForeignData (kObject object)
| Reports whether the object, including aggregated child elements, contains any foreign memory references. More...
kSize | kObject_HashCode (kObject object)
| Gets a hash code representing the state of this object. More...
kBool | kObject_Is (kObject object, kType type)
| Determines whether this object is an instance of the specified type. More...
kBool | kObject_IsShared (kObject object)
| Reports whether the object is currently shared (reference count greater than one). More...
kStatus | kObject_SetPool (kObject object, kObjectPool pool)
| Sets the object pool associated with this object. More...
kStatus | kObject_Share (kObject object)
| Increments the reference count associated with this object. More...
kSize | kObject_Size (kObject object)
| Estimates the memory consumed by this object, including any aggregated child elements. More...
kType | kObject_Type (kObject object)
| Returns the type of the object. More...
Public Member Functions inherited from kCollection
kSize | kCollection_Count (kCollection collection)
| Gets the collection element count. More...
kIterator | kCollection_GetIterator (kCollection collection)
| Returns an iterator to the first element in the collection. More...
kBool | kCollection_HasNext (kCollection collection, kIterator iterator)
| Determines whether a collection has another item. More...
kType | kCollection_ItemType (kCollection collection)
| Gets the collection element type. More...
void * | kCollection_Next (kCollection collection, kIterator *iterator)
| Gets a pointer to the next collection element and then advances the iterator. More...

## Related
#define | kArray1_AsT(kArray1_array, kSize_index, T)
| Gets the value of an item. More...
#define | kArray1_AtT(kArray1_array, kSize_index, T)
| Returns a strongly-typed pointer to the specified item in the array. More...
#define | kArray1_AttachT(kArray1_array, TPtr_items, kType_itemType, kSize_length)
| Attaches the array to an external item buffer. More...
#define | kArray1_DataAtT(kArray1_array, kSSize_index, T)
| Calculates an address relative to the start of the buffer. More...
#define | kArray1_DataT(kArray1_array, T)
| Returns a strongly-typed pointer to the array item buffer. More...
#define | kArray1_ItemT(kArray1_array, kSize_index, TPtr_item)
| Gets the value of an item. More...
#define | kArray1_SetAsT(kArray1_array, kSize_index, T_value, T)
| Sets the value of an item. More...
#define | kArray1_SetItemT(kArray1_array, kSize_index, TPtr_item)
| Sets the value of an item. More...
Related inherited from kCollection
#define | kCollection_NextT(kCollection_collection, kIteratorPtr_iterator, T)
| Gets a strongly-typd pointer to next collection element and then advances the iterator. More...

## Additional Inherited Members
Protected Member Functions inherited from kObject
kStatus | kObject_FreeMem (kObject object, void *mem)
| Protected method called by derived classes to free memory using the object's allocator. More...
kStatus | kObject_FreeMemRef (kObject object, void *mem)
| Protected method called by derived classes to free memory (and reset the provided memory pointer to kNULL) using the object's allocator. More...
kStatus | kObject_GetMem (kObject object, kSize size, void *mem)
| Protected method called by derived classes to allocate memory using the object's allocator. More...
kStatus | kObject_GetMemZero (kObject object, kSize size, void *mem)
| Protected method called by derived classes to allocate and zero memory using the object's allocator. More...
kStatus | kObject_Init (kObject object, kType type, kAlloc alloc)
| Protected method called by derived classes to initialize the kObject base class. More...
kStatus | kObject_VDisposeItems (kObject object)
| Protected virtual method that destroys any aggregated child objects associated with a collection. More...
kBool | kObject_VEquals (kObject object, kObject other)
| Protected virtual method that compares two objects for equality. More...
kBool | kObject_VHasForeignData (kObject object)
| Protected virtual method that reports whether the object, including aggregated child elements, contains any foreign memory references. More...
kSize | kObject_VHashCode (kObject object)
| Protected virtual method that calculates a hash code representing the object instance. More...
kStatus | kObject_VInitClone (kObject object, kObject source, kAlloc allocator)
| Protected virtual method that clones (makes a deep copy of) the specified source object. More...
kStatus | kObject_VRelease (kObject object)
| Protected virtual method that deallocates any resources owned by the object. More...
kSize | kObject_VSize (kObject object)
| Protected virtual method that calculates the total size (in bytes) of the object instance. More...

The documentation for this class was generated from the following file:

- Data/kArray1.h